import * as tslib_1 from "tslib";
import CopyWebpackPlugin from 'copy-webpack-plugin';
import { DllPlugin, DllReferencePlugin } from './plugins';
import path from 'path';
export default function mwDLL(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var dll, plugins, DIRs, libraryName, dllPath, manifest, dllFileName;
    return tslib_1.__generator(this, function (_a) {
      context.dll = false;
      context.DLL_FILENAME = false;
      next();
      dll = context.dll, plugins = context.plugins, DIRs = context.DIRs;
      libraryName = '[name]_[hash]';

      if (Array.isArray(dll)) {
        plugins.push(new DllPlugin({
          path: path.resolve(DIRs.build, 'manifest.json'),
          name: libraryName,
          context: context.context || context.cwd
        }));
        context.output = {
          path: DIRs.build,
          filename: libraryName + ".js",
          library: libraryName
        };
        context.entry = {
          dll: dll
        };
      }

      if (typeof dll === 'string' || dll === true) {
        dllPath = dll === true ? path.resolve(DIRs.root, 'dll') : dll;
        manifest = require(path.join(dllPath, 'manifest.json'));
        dllFileName = manifest.name + ".js";
        plugins.push(new DllReferencePlugin({
          context: context.context || context.cwd,
          manifest: manifest
        }));
        plugins.push(new CopyWebpackPlugin([{
          from: path.join(dllPath, dllFileName),
          to: DIRs.build
        }]));
        context.DLL_FILENAME = dllFileName;
      }

      return [2];
    });
  });
}