import * as tslib_1 from "tslib";
import { HotModuleReplacementPlugin } from './plugins';
import getStats from './getStats';
var DEFAULT_PORT = 8080;
var DEFAULT_HOST = '0.0.0.0';

function parseProxyWithOptions(proxy, options) {
  var oo = {};
  var keys = Object.keys(proxy);
  keys.forEach(function (key) {
    var target = proxy[key];
    oo[key] = typeof target === 'string' ? tslib_1.__assign({
      target: target
    }, options) : tslib_1.__assign({}, target, options);
  });
  return oo;
}

function parseStringProxy(proxy) {
  if (typeof proxy === 'string') {
    proxy = {
      '*': proxy
    };
  }

  return proxy;
}

export default function mwDevServer(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var devServer, proxy, proxyOptions, plugins, DIRs, packageMap, proxyObj;
    return tslib_1.__generator(this, function (_a) {
      context.devServer = {};
      context.proxy = {};
      context.proxyOptions = {
        changeOrigin: true
      };
      context.isDevServer = true;
      next();
      devServer = context.devServer, proxy = context.proxy, proxyOptions = context.proxyOptions, plugins = context.plugins, DIRs = context.DIRs, packageMap = context.packageMap;
      proxyObj = parseProxyWithOptions(tslib_1.__assign({}, parseStringProxy(packageMap.proxy), proxy), proxyOptions);
      context.webpackConfig.devServer = context.devServer = tslib_1.__assign({
        port: context.port || DEFAULT_PORT,
        host: DEFAULT_HOST,
        hot: true,
        hotOnly: true,
        contentBase: DIRs.root,
        watchContentBase: true,
        compress: true,
        quiet: false,
        disableHostCheck: true,
        clientLogLevel: 'none',
        overlay: false,
        headers: {
          'Access-Control-Allow-Origin': '*'
        },
        historyApiFallback: {
          disableDotRule: true
        },
        proxy: proxyObj,
        stats: getStats(false)
      }, devServer);
      plugins.push(new HotModuleReplacementPlugin());
      return [2];
    });
  });
}