import * as tslib_1 from "tslib";
import path from 'path';
import { DefinePlugin } from './plugins';
import { getValueByPath } from './util';
export default function mwENV(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var _a, default_node_env, cwd, outputPath, env, ASSET_PATH, isProduction, isDevelopment, isBeta, root, src, build;

    return tslib_1.__generator(this, function (_b) {
      default_node_env = context.default_node_env, cwd = context.cwd, outputPath = context.outputPath;
      env = process.env.NODE_ENV || default_node_env || 'development';
      ASSET_PATH = process.env.ASSET_PATH || '';
      context.ASSET_PATH = ASSET_PATH;
      isProduction = env === 'production';
      isDevelopment = env === 'development';
      isBeta = env === 'beta';
      context.ENV = {
        isProduction: isProduction,
        isDevelopment: isDevelopment,
        isBeta: isBeta,
        env: env
      };
      root = cwd;
      src = path.resolve(root, 'src');
      build = path.resolve(root, outputPath);
      context.DIRs = {
        root: root,
        cwd: root,
        src: src,
        source: src,
        build: build,
        dist: build
      };
      context.packageMap = getValueByPath(path.join(cwd, 'package.json'));
      next();
      context.webpackConfig.plugins.push(new DefinePlugin((_a = {
        __DEV__: isDevelopment
      }, _a['process.env.NODE_ENV'] = JSON.stringify(env), _a['process.env.ASSET_PATH'] = JSON.stringify(ASSET_PATH), _a)));
      return [2, context];
    });
  });
}