import * as tslib_1 from "tslib";
import HTMLWebpackPlugin from 'html-webpack-plugin';
import CopyWebpackPlugin from 'copy-webpack-plugin';
import { DefinePlugin, ProvidePlugin } from './plugins';
import { getBuildCopyFiles, getBuildExternals, getBuildHTML } from './util';
export default function mwMultiEntryHTML(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var packageMap, plugins, ENV, __IS_BUILD_LIBRARY__, version, versionTail;

    return tslib_1.__generator(this, function (_a) {
      next();
      packageMap = context.packageMap, plugins = context.plugins, ENV = context.ENV, __IS_BUILD_LIBRARY__ = context.__IS_BUILD_LIBRARY__;

      if (__IS_BUILD_LIBRARY__ === true) {
        return [2];
      }

      plugins.push(new CopyWebpackPlugin(getBuildCopyFiles(context.files)));
      context.externals = getBuildExternals(tslib_1.__assign({}, context.files, context.externals));
      version = context.version || packageMap.version || '0.0.0';
      versionTail = ENV.isBeta ? '-beta' : ENV.isDevelopment ? '-dev' : '';
      plugins.push(new DefinePlugin(tslib_1.__assign({
        VERSION: JSON.stringify(version),
        APPLICATION_VERSION: JSON.stringify("v" + version + versionTail)
      }, context.defines)), new ProvidePlugin(context.provides));
      getBuildHTML(context).forEach(function (line) {
        return plugins.push(new HTMLWebpackPlugin(line));
      });
      return [2];
    });
  });
}