import * as tslib_1 from "tslib";
import path from 'path';
import ManifestPlugin from 'webpack-manifest-plugin';
import WorkboxWebpackPlugin from 'workbox-webpack-plugin';
import WebpackPWAManifest from 'webpack-pwa-manifest';
export default function mwPWA(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var plugins, _a, publicPath, packageMap, pwaManifestOptions, _b, enablePWA, publicURL;

    return tslib_1.__generator(this, function (_c) {
      next();
      plugins = context.plugins, _a = context.publicPath, publicPath = _a === void 0 ? '/' : _a, packageMap = context.packageMap, pwaManifestOptions = context.pwaManifestOptions, _b = context.enablePWA, enablePWA = _b === void 0 ? false : _b;

      if (!enablePWA) {
        return [2];
      }

      publicURL = publicPath.slice(0, -1);
      plugins.push(new ManifestPlugin({
        fileName: 'asset-manifest.json',
        publicPath: publicPath
      }), new WorkboxWebpackPlugin.GenerateSW({
        clientsClaim: true,
        exclude: [/\.map$/, /asset-manifest\.json$/],
        importWorkboxFrom: 'cdn',
        navigateFallback: publicURL + '/index.html',
        navigateFallbackBlacklist: [new RegExp('^/_'), new RegExp('/[^/]+\\.[^/]+$')]
      }), new WebpackPWAManifest(tslib_1.__assign({
        name: packageMap.name,
        short_name: packageMap.name,
        description: packageMap.description,
        background_color: '#ffffff',
        crossorigin: 'use-credentials',
        icons: [{
          src: path.join(__dirname, '../assets/favicon.ico'),
          sizes: [32]
        }]
      }, pwaManifestOptions)));
      return [2];
    });
  });
}