import * as tslib_1 from "tslib";
import fs from 'fs';
import path from 'path';
import tsImportPluginFactory from 'ts-import-plugin';
export default function (context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var cwd, ENV, typescriptConfigPath, options, tsconfigPath, importPluginOptions;
    return tslib_1.__generator(this, function (_a) {
      cwd = context.cwd, ENV = context.ENV;
      typescriptConfigPath = path.join(__dirname, '../tsconfig.json');
      options = require(typescriptConfigPath);
      tsconfigPath = path.resolve(cwd, 'tsconfig.json');

      if (fs.existsSync(tsconfigPath)) {
        options = require(tsconfigPath);
      }

      options.compilerOptions.sourceMap = ENV.isDevelopment;
      options.compilerOptions.module = 'ESNEXT';
      context.typescriptOptions = context.tsOptions = {
        transpileOnly: true,
        happyPackMode: true,
        experimentalWatchApi: true,
        compilerOptions: options.compilerOptions
      };
      next();
      importPluginOptions = context.importPluginOptions;

      if (importPluginOptions) {
        context.tsOptions.getCustomTransformers = function () {
          return {
            before: importPluginOptions.map(function (o) {
              return tsImportPluginFactory(o);
            })
          };
        };
      }

      return [2];
    });
  });
}