"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mwBabelOptions;

var tslib_1 = _interopRequireWildcard(require("tslib"));

function mwBabelOptions(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var commonPresets, commonPlugins, _a, optimizeDynamicImport, _b, optimizeLodash, _c, useBabelrc, importPluginOptions;

    return tslib_1.__generator(this, function (_d) {
      commonPresets = [['@babel/preset-env', {
        targets: {
          chrome: '39',
          edge: '12',
          ie: '10',
          firefox: '33',
          safari: '9',
          node: '4',
          ios: '9'
        },
        modules: false,
        useBuiltIns: 'entry',
        corejs: 3
      }], '@babel/preset-react'];
      commonPlugins = ['@babel/plugin-external-helpers', '@babel/plugin-transform-runtime', '@babel/plugin-transform-object-assign', '@babel/plugin-syntax-dynamic-import', '@babel/plugin-proposal-async-generator-functions', '@babel/plugin-transform-regenerator', '@babel/plugin-proposal-function-bind', '@babel/plugin-proposal-object-rest-spread', ['@babel/plugin-proposal-decorators', {
        legacy: true
      }], ['@babel/plugin-proposal-class-properties', {
        loose: true
      }]];
      context.babelOptions = {
        cacheDirectory: true,
        babelrc: false,
        highlightCode: true,
        presets: commonPresets,
        plugins: commonPlugins
      };
      next();
      _a = context.optimizeDynamicImport, optimizeDynamicImport = _a === void 0 ? context.ENV.isDevelopment : _a, _b = context.optimizeLodash, optimizeLodash = _b === void 0 ? true : _b, _c = context.useBabelrc, useBabelrc = _c === void 0 ? false : _c, importPluginOptions = context.importPluginOptions;

      if (useBabelrc) {
        context.babelOptions.babelrc = true;
      }

      if (optimizeDynamicImport) {
        commonPlugins.push('babel-plugin-dynamic-import-node');
      }

      if (optimizeLodash) {
        commonPlugins.push('babel-plugin-lodash');
      }

      if (importPluginOptions) {
        commonPlugins.push.apply(commonPlugins, importPluginOptions.map(function (o) {
          return ['babel-plugin-import', o];
        }));
      }

      return [2];
    });
  });
}