"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mwDLL;

var tslib_1 = _interopRequireWildcard(require("tslib"));

var _copyWebpackPlugin = _interopRequireDefault(require("copy-webpack-plugin"));

var _plugins = require("./plugins");

var _path = _interopRequireDefault(require("path"));

function mwDLL(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var dll, plugins, DIRs, libraryName, dllPath, manifest, dllFileName;
    return tslib_1.__generator(this, function (_a) {
      context.dll = false;
      context.DLL_FILENAME = false;
      next();
      dll = context.dll, plugins = context.plugins, DIRs = context.DIRs;
      libraryName = '[name]_[hash]';

      if (Array.isArray(dll)) {
        plugins.push(new _plugins.DllPlugin({
          path: _path.default.resolve(DIRs.build, 'manifest.json'),
          name: libraryName,
          context: context.context || context.cwd
        }));
        context.output = {
          path: DIRs.build,
          filename: libraryName + ".js",
          library: libraryName
        };
        context.entry = {
          dll: dll
        };
      }

      if (typeof dll === 'string' || dll === true) {
        dllPath = dll === true ? _path.default.resolve(DIRs.root, 'dll') : dll;
        manifest = require(_path.default.join(dllPath, 'manifest.json'));
        dllFileName = manifest.name + ".js";
        plugins.push(new _plugins.DllReferencePlugin({
          context: context.context || context.cwd,
          manifest: manifest
        }));
        plugins.push(new _copyWebpackPlugin.default([{
          from: _path.default.join(dllPath, dllFileName),
          to: DIRs.build
        }]));
        context.DLL_FILENAME = dllFileName;
      }

      return [2];
    });
  });
}