"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mwMultiEntryHTML;

var tslib_1 = _interopRequireWildcard(require("tslib"));

var _htmlWebpackPlugin = _interopRequireDefault(require("html-webpack-plugin"));

var _copyWebpackPlugin = _interopRequireDefault(require("copy-webpack-plugin"));

var _plugins = require("./plugins");

var _util = require("./util");

function mwMultiEntryHTML(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var packageMap, plugins, ENV, __IS_BUILD_LIBRARY__, version, versionTail;

    return tslib_1.__generator(this, function (_a) {
      next();
      packageMap = context.packageMap, plugins = context.plugins, ENV = context.ENV, __IS_BUILD_LIBRARY__ = context.__IS_BUILD_LIBRARY__;

      if (__IS_BUILD_LIBRARY__ === true) {
        return [2];
      }

      plugins.push(new _copyWebpackPlugin.default((0, _util.getBuildCopyFiles)(context.files)));
      context.externals = (0, _util.getBuildExternals)(tslib_1.__assign({}, context.files, context.externals));
      version = context.version || packageMap.version || '0.0.0';
      versionTail = ENV.isBeta ? '-beta' : ENV.isDevelopment ? '-dev' : '';
      plugins.push(new _plugins.DefinePlugin(tslib_1.__assign({
        VERSION: JSON.stringify(version),
        APPLICATION_VERSION: JSON.stringify("v" + version + versionTail)
      }, context.defines)), new _plugins.ProvidePlugin(context.provides));
      (0, _util.getBuildHTML)(context).forEach(function (line) {
        return plugins.push(new _htmlWebpackPlugin.default(line));
      });
      return [2];
    });
  });
}