"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mwPWA;

var tslib_1 = _interopRequireWildcard(require("tslib"));

var _path = _interopRequireDefault(require("path"));

var _webpackManifestPlugin = _interopRequireDefault(require("webpack-manifest-plugin"));

var _workboxWebpackPlugin = _interopRequireDefault(require("workbox-webpack-plugin"));

var _webpackPwaManifest = _interopRequireDefault(require("webpack-pwa-manifest"));

function mwPWA(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var plugins, _a, publicPath, packageMap, pwaManifestOptions, _b, enablePWA, publicURL;

    return tslib_1.__generator(this, function (_c) {
      next();
      plugins = context.plugins, _a = context.publicPath, publicPath = _a === void 0 ? '/' : _a, packageMap = context.packageMap, pwaManifestOptions = context.pwaManifestOptions, _b = context.enablePWA, enablePWA = _b === void 0 ? false : _b;

      if (!enablePWA) {
        return [2];
      }

      publicURL = publicPath.slice(0, -1);
      plugins.push(new _webpackManifestPlugin.default({
        fileName: 'asset-manifest.json',
        publicPath: publicPath
      }), new _workboxWebpackPlugin.default.GenerateSW({
        clientsClaim: true,
        exclude: [/\.map$/, /asset-manifest\.json$/],
        importWorkboxFrom: 'cdn',
        navigateFallback: publicURL + '/index.html',
        navigateFallbackBlacklist: [new RegExp('^/_'), new RegExp('/[^/]+\\.[^/]+$')]
      }), new _webpackPwaManifest.default(tslib_1.__assign({
        name: packageMap.name,
        short_name: packageMap.name,
        description: packageMap.description,
        background_color: '#ffffff',
        crossorigin: 'use-credentials',
        icons: [{
          src: _path.default.join(__dirname, '../assets/favicon.ico'),
          sizes: [32]
        }]
      }, pwaManifestOptions)));
      return [2];
    });
  });
}