"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var tslib_1 = _interopRequireWildcard(require("tslib"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _tsImportPlugin = _interopRequireDefault(require("ts-import-plugin"));

function _default(context, next) {
  return tslib_1.__awaiter(this, void 0, void 0, function () {
    var cwd, ENV, typescriptConfigPath, options, tsconfigPath, importPluginOptions;
    return tslib_1.__generator(this, function (_a) {
      cwd = context.cwd, ENV = context.ENV;
      typescriptConfigPath = _path.default.join(__dirname, '../tsconfig.json');
      options = require(typescriptConfigPath);
      tsconfigPath = _path.default.resolve(cwd, 'tsconfig.json');

      if (_fs.default.existsSync(tsconfigPath)) {
        options = require(tsconfigPath);
      }

      options.compilerOptions.sourceMap = ENV.isDevelopment;
      options.compilerOptions.module = 'ESNEXT';
      context.typescriptOptions = context.tsOptions = {
        transpileOnly: true,
        happyPackMode: true,
        experimentalWatchApi: true,
        compilerOptions: options.compilerOptions
      };
      next();
      importPluginOptions = context.importPluginOptions;

      if (importPluginOptions) {
        context.tsOptions.getCustomTransformers = function () {
          return {
            before: importPluginOptions.map(function (o) {
              return (0, _tsImportPlugin.default)(o);
            })
          };
        };
      }

      return [2];
    });
  });
}