import { Plugin } from 'webpack';
export declare type File = {
    name: string;
    path: string;
    to: string;
} | string;
export declare type FilesMap = {
    [key: string]: File;
};
export declare type ENVValue = 'development' | 'beta' | 'production';
export declare type Next = () => void;
export declare type ENV = {
    isProduction: boolean;
    isDevelopment: boolean;
    isBeta: boolean;
    env: ENVValue;
};
export declare type Entry = string | {
    [key: string]: string;
} | string[];
export declare type PackageMap = {
    name: string;
    description: string;
    entry?: Entry;
    browser?: any;
    theme?: string | object;
    version: string;
    proxy?: string | object;
};
export declare type Context = {
    entry: Entry;
    packageMap: PackageMap;
    ENV: ENV;
    DIRs: {
        root: string;
        cwd: string;
        src: string;
        source: string;
        build: string;
        dist: string;
    };
    babelOptions: object & {
        cacheDirectory: boolean;
        babelrc: boolean;
        highlightCode: boolean;
        presets: any[];
        plugins: any[];
    };
    typescriptOptions: object;
    tsOptions: any;
    importPluginOptions: object[];
    enableHappyPack: boolean;
    enablePWA: boolean;
    pwaManifestOptions: object;
    postcssOptions: {
        sourceMap: boolean;
        plugins: any[];
    };
    publicPath: string;
    hash: boolean;
    compress: boolean;
    plugins: Plugin[];
    dll: boolean | string | string[];
    DLL_FILENAME: boolean | string;
    proxy: string | object;
    proxyOptions: object;
    isDevServer: boolean;
    port: string | number;
    devServer: any;
    output: string | {
        path?: string;
        filename?: string;
        library?: string;
        chunkFilename?: string;
        globalObject?: string;
        pathinfo?: boolean;
        publicPath?: string;
    };
    context: string;
    webpackConfig: any | any[];
    records: boolean | string | object;
    analyzer: boolean | object;
    optimizeLodash: boolean | object;
    verbose: boolean;
    watch: boolean;
    files: File[];
    externals: FilesMap;
    version: string;
    provides: {
        [p: string]: any;
    };
    __IS_BUILD_LIBRARY__?: boolean;
    [key: string]: any;
};
