/// <reference types="webpack-dev-server" />
import notifier from 'node-notifier';
import chalk from 'chalk';
import { Context, Entry, ENV, ENVValue, File, FilesMap, PackageMap } from './types';
import { Configuration } from 'webpack';
export { notifier, chalk };
export declare function getProgressHandler(percent: number, msg1: string, msg2: string): void;
export declare function checkWebpackConfig(webpackConfig: Configuration): void;
export declare function getValueByPath(path: string): any;
export declare function getBuildCopyFiles(files: File[]): any;
export declare function getBuildExternals(files: FilesMap): FilesMap;
export declare function getBuild4DevelopmentENV(filesMap: FilesMap): File[];
export declare function getBuild4ProductionENV(filesMap: FilesMap): File[];
export declare function getBuildHTMLData(filesMap: FilesMap, env: ENVValue): File[];
export declare function getBuildHTML(context: Context): any[];
export declare function createDomain({ host, port }: {
    host: string;
    port: string | number;
}): string;
export declare function getNodeVersion(packageMap: PackageMap): {};
export declare function getBuildSourceMap(devtool: boolean | string, ENV: ENV): string | false;
export declare function getBuildTemplateParametersWithScripts(scripts: any[]): (compilation: any, assets: any, options: any) => {
    compilation: any;
    webpack: any;
    webpackConfig: any;
    htmlWebpackPlugin: {
        files: any;
        options: any;
        scripts: any;
        styles: any;
    };
};
export declare function getOptions<T>(options: boolean | string | object, defaultOptions?: any): T;
export declare function PromiseDefer<T>(): {
    promise: Promise<T>;
    resolve: Function;
    reject: Function;
};
export declare function getExampleEntry(context: Context): Entry;
